﻿; *******************************************************************************************************************************************************
; AUTHOR        : MicrodevWeb
; PROJECT NAME  : FAC
; MODULE NAME   : Facture
; VERSION       : 1
; REQUIERED     : PB 5.60
; *******************************************************************************************************************************************************
DeclareModule Facture
  ;======================================================================================================================================================
  ;-* PRIVATE macro
  ; -----------------------------------------------------------------------------------------------------------------------------------------------------
  Macro mError(FunctionName,Message,ValReturn)
    MessageRequester("Facture Error ("+FunctionName+")",Message,#PB_MessageRequester_Error)
    ProcedureReturn ValReturn
  EndMacro
  ;}-----------------------------------------------------------------------------------------------------------------------------------------------------
  ;======================================================================================================================================================
  ;-* PUBLIC CONSTANTE
  ; -----------------------------------------------------------------------------------------------------------------------------------------------------
  ;}-----------------------------------------------------------------------------------------------------------------------------------------------------
  ;======================================================================================================================================================
  ;-* PUBLIC INTERFACE
  ; -----------------------------------------------------------------------------------------------------------------------------------------------------
  ;}-----------------------------------------------------------------------------------------------------------------------------------------------------
  ;======================================================================================================================================================
  ;-* PUBLIC PROTOTYPES
  ; -----------------------------------------------------------------------------------------------------------------------------------------------------
  Declare Open(motherWindow,TabCli,TabPro)
  ;}-----------------------------------------------------------------------------------------------------------------------------------------------------
EndDeclareModule
Module Facture
  EnableExplicit
  UseSQLiteDatabase()
  ;======================================================================================================================================================
  ;-* PRIVATE CONSTANTE
  ; -----------------------------------------------------------------------------------------------------------------------------------------------------
  ;}-----------------------------------------------------------------------------------------------------------------------------------------------------
  ;======================================================================================================================================================
  ;-* PRIVATE STRUCTURES
  ; -----------------------------------------------------------------------------------------------------------------------------------------------------
  ;}-----------------------------------------------------------------------------------------------------------------------------------------------------
  ;======================================================================================================================================================
  ;-* PRIVATE VARIABLES
  ; -----------------------------------------------------------------------------------------------------------------------------------------------------
  Global gForm,gMotherWindow
  Global.RAD::_FicForm FactureFic,LgnFactureFic
  Global.RAD::_TabForm *gTabCli,*gTabPro
  Global.TBL::_TBL TableFac,TableLgn
  Global Font=LoadFont(#PB_Any,"Arial",11,#PB_Font_HighQuality)
  Global FontH=LoadFont(#PB_Any,"Arial",14,#PB_Font_HighQuality)
  
  ;}-----------------------------------------------------------------------------------------------------------------------------------------------------
  ;======================================================================================================================================================
  ;-* PRIVATE PROTOTYPES
  ; -----------------------------------------------------------------------------------------------------------------------------------------------------
  ;}-----------------------------------------------------------------------------------------------------------------------------------------------------
  ;======================================================================================================================================================
  ;-* PRIVATE FUNCTIONS
  ; -----------------------------------------------------------------------------------------------------------------------------------------------------
  Procedure.s MakeXml()
    Protected xml.s
    xml+"<window name='Facture' widht='800' height='600'"+
        " text="+Chr(34)+"Liste des factures"+Chr(34)+
        " flags='#PB_Window_SystemMenu|#PB_Window_MaximizeGadget|#PB_Window_SizeGadget|#PB_Window_WindowCentered'>"+Chr(10)+
        "   <vbox>"+Chr(10)+
        "       <hbox expand='item:1'>"+Chr(10)+
        "           <vbox expand='item:2'>"+Chr(10)+
        "               <text name='Lb_Fac' text='Liste des factures' flags='#PB_Text_center'   height='30'/>"+Chr(10)+
        "               <canvas name='canvas_facture' flags='#PB_Canvas_Container|#PB_Canvas_Keyboard|#PB_Canvas_Border' />"+Chr(10)+
        "           </vbox>"+Chr(10)+                                                                                                  
        "           <vbox expand='no'>"+Chr(10)+
        "               <empty height='30'/>"+Chr(10)+
        "               <button name='bt_addFac' text='Nouvelle'/>"+Chr(10)+
        "               <button name='bt_editFac' text='Editer'/>"+Chr(10)+
        "               <button name='bt_deleteFac' text='Supprimer'/>"+Chr(10)+
        "               <button name='bt_Exit' text='Quitter'/>"+Chr(10)+
        "            </vbox>"+Chr(10)+
        "        </hbox>"+Chr(10)+
        "       <hbox expand='item:1'>"+Chr(10)+
        "           <vbox expand='item:1'>"+Chr(10)+
        "               <vbox expand='item:2'>"+Chr(10)+
        "                   <text name='Lb_Lgn' text='Détail de la facture' flags='#PB_Text_Center'   height='30'/>"+Chr(10)+
        "                   <canvas name='canvas_Lgn' flags='#PB_Canvas_Container|#PB_Canvas_Keyboard|#PB_Canvas_Border'/>"+Chr(10)+
        "                </vbox>"+Chr(10)+  
        "               <vbox expand='no'  align='right'>"+Chr(10)+
        "                  <text name='total' text='' flags='#PB_Text_Right'   height='30'/>"+Chr(10)+
        "                  <text name='tva' text='' flags='#PB_Text_Right'   height='30'/>"+Chr(10)+
        "                  <text name='ttc' text='' flags='#PB_Text_Right'   height='30'/>"+Chr(10)+
        "               </vbox>"+Chr(10)+
        "           </vbox>"+Chr(10)+                                 
        "           <vbox expand='no'>"+Chr(10)+
        "             <empty height='30'/>"+Chr(10)+
        "             <button name='bt_addLgn' text='Ajouter'/>"+Chr(10)+
        "             <button name='bt_editLgn' text='Editer'/>"+Chr(10)+
        "             <button name='bt_deleteLgn' text='Supprimer'/>"+Chr(10)+
        "           </vbox>"+Chr(10)+
        "        </hbox>"+Chr(10)+
        "   </vbox>"+Chr(10)+
        "</window>"
    
    CreateFile(0,"Facture.xml")
    WriteString(0,xml)
    CloseFile(0)
    ProcedureReturn xml
  EndProcedure
  Procedure Exit()
    CloseWindow(DialogWindow(gForm))
    TableFac\Free()
    DisableWindow(gMotherWindow,#False)
    SetActiveWindow(gMotherWindow)
  EndProcedure
  Procedure.s FacTTC(id)
    Protected req.s,idDb,txt.s
    req="SELECT sum((lgn_facture.qte * lgn_facture.pa) * ( (100 +lgn_facture.tva)/100)) "+
        "FROM lgn_facture "+
        " WHERE lgn_facture.id_facture="+Str(id)
    idDb=DB::Query(req)
    FirstDatabaseRow(idDb)
    txt=FormatNumber(GetDatabaseFloat(idDb,0),2,"."," ")+" €"
    CloseDatabase(idDb)
    ProcedureReturn txt
  EndProcedure
  Procedure.s FacTotal(id)
    Protected req.s,idDb,txt.s
    req="SELECT sum(lgn_facture.qte * lgn_facture.pa) "+
        "FROM lgn_facture "+
        " WHERE lgn_facture.id_facture="+Str(id)
    idDb=DB::Query(req)
    FirstDatabaseRow(idDb)
    txt=FormatNumber(GetDatabaseFloat(idDb,0),2,"."," ")+" €"
    CloseDatabase(idDb)
    ProcedureReturn txt
  EndProcedure
  Procedure.s FacTVA(id)
    Protected req.s,idDb,txt.s
    req="SELECT sum((lgn_facture.qte * lgn_facture.pa) * (lgn_facture.tva / 100)) "+
        "FROM lgn_facture "+
        " WHERE lgn_facture.id_facture="+Str(id)
    idDb=DB::Query(req)
    FirstDatabaseRow(idDb)
    txt=FormatNumber(GetDatabaseFloat(idDb,0),2,"."," ")+" €"
    CloseDatabase(idDb)
    ProcedureReturn txt
  EndProcedure
  Procedure.s LgnTva(id)
    Protected req.s,idDb,txt.s
    req="SELECT (lgn_facture.pa * lgn_facture.qte) * (lgn_facture.tva / 100) FROM lgn_facture "+
        " WHERE lgn_facture.id="+Str(id)
    idDb=DB::Query(req)
    FirstDatabaseRow(idDb)
    txt=FormatNumber(GetDatabaseFloat(idDb,0),2,"."," ")+" €"
    CloseDatabase(idDb)
    ProcedureReturn txt
  EndProcedure
  Procedure.s LgnTotal(id)
    Protected req.s,idDb,txt.s
    req="SELECT lgn_facture.pa * lgn_facture.qte FROM lgn_facture "+
        " WHERE lgn_facture.id="+Str(id)
    idDb=DB::Query(req)
    FirstDatabaseRow(idDb)
    txt=FormatNumber(GetDatabaseFloat(idDb,0),2,"."," ")+" €"
    CloseDatabase(idDb)
    ProcedureReturn txt
  EndProcedure
  Procedure.s LgnTTC(id)
    Protected req.s,idDb,txt.s
    req="SELECT (lgn_facture.pa * lgn_facture.qte) * ((100 + lgn_facture.tva) / 100) FROM lgn_facture "+
        " WHERE lgn_facture.id="+Str(id)
    idDb=DB::Query(req)
    FirstDatabaseRow(idDb)
    txt=FormatNumber(GetDatabaseFloat(idDb,0),2,"."," ")+" €"
    CloseDatabase(idDb)
    ProcedureReturn txt
  EndProcedure
  Procedure ShowTotal() 
    Protected req.s,idDb,txt.s,id
    id=TableFac\GetIdSelected()
    If id=-1
      SetGadgetText(DialogGadget(gForm,"total"),"")
      SetGadgetText(DialogGadget(gForm,"tva"),"")
      SetGadgetText(DialogGadget(gForm,"ttc"),"")
    EndIf
    req="SELECT sum(lgn_facture.qte * lgn_facture.pa), "+
        "sum((lgn_facture.qte * lgn_facture.pa) * (lgn_facture.tva / 100)), "+
        "sum((lgn_facture.qte * lgn_facture.pa) * ( (100 +lgn_facture.tva)/100))"+
        " FROM lgn_facture "+
        " WHERE lgn_facture.id_facture="+Str(id)
    idDb=DB::Query(req)
    FirstDatabaseRow(idDb)
    txt="TOTAL      :"+FormatNumber(GetDatabaseFloat(idDb,0),2,"."," ")+" €"
    SetGadgetText(DialogGadget(gForm,"total"),txt)
    txt="TVA        :"+FormatNumber(GetDatabaseFloat(idDb,1),2,"."," ")+" €"
    SetGadgetText(DialogGadget(gForm,"tva"),txt)
    txt="TOTAL TVAX :"+FormatNumber(GetDatabaseFloat(idDb,2),2,"."," ")+" €"
    SetGadgetText(DialogGadget(gForm,"ttc"),txt)
    CloseDatabase(idDb)
  EndProcedure
  Procedure RefreshFormFac()
    TableFac\RefreshMe()
    ShowTotal() 
  EndProcedure
  Procedure RefreshFormLgn()
    TableFac\RefreshMe()
    TableLgn\RefreshMe()
    ShowTotal() 
  EndProcedure
  Procedure NewFac()
    Protected IdNumero,Num.s,req.s,idDb,Nb
    FactureFic\Open(DialogWindow(gForm),0,@RefreshFormFac())
    ; On désactive le champ numero
    IdNumero=FactureFic\GetGadgetId("numero")
    DisableGadget(IdNumero,#True)
    ; Calcul du numéro
    req="SELECT COUNT(*) FROM facture WHERE date LIKE "+
        Chr(34)+FormatDate("%YYYY",Date())+"%"+Chr(34)
    idDb=DB::Query(req)
    FirstDatabaseRow(idDb)
    nb=GetDatabaseLong(idDb,0)
    CloseDatabase(idDb)
    Num="FAC"+FormatDate("%YY",Date())+RSet(Str(nb+1),8,"0")
    SetGadgetText(IdNumero,Num)
  EndProcedure
  Procedure NewLgn()
    If TableFac\GetIdSelected()=-1
      ProcedureReturn 
    EndIf
    LgnFactureFic\SetGadgetValue("id_facture",Str(TableFac\GetIdSelected()))
    LgnFactureFic\Open(DialogWindow(gForm),0,@RefreshFormLgn())
  EndProcedure
  Procedure SetTva()
    Protected idPro=LgnFactureFic\GetGadgetId("id_produit")
    Protected id=GetGadgetItemData(idPro,GetGadgetState(idPro))
    Protected req.s,idDb
    If id<>-1
      req="SELECT produit.pv,tva.taux FROM produit "+
          "LEFT JOIN tva ON tva.id=produit.id_tva "+
          "WHERE produit.id="+Str(id)
      idDb=DB::Query(req)
      FirstDatabaseRow(idDb)
      LgnFactureFic\SetGadgetValue("pa",StrF(GetDatabaseFloat(idDb,0)))
      LgnFactureFic\SetGadgetValue("tva",StrF(GetDatabaseFloat(idDb,1)))
      CloseDatabase(idDb)
    EndIf
  EndProcedure
  Procedure MakeFormFic()
    FactureFic=FicForm::New("facture","Nouvelle facture","Edition d'une facture")
    FactureFic\AddGadget("numero")
    FactureFic\AddGadget("date")
    FactureFic\AddGadget("id_client",0,*gTabCli)
    FactureFic\SetSize(300,0,0,0)
    LgnFactureFic=FicForm::New("lgn_facture","Nouvelle ligne de facture","Edition d'une ligne de facture")
    LgnFactureFic\AddGadget("id_produit",0,*gTabPro)
    LgnFactureFic\AddGadget("qte")
    LgnFactureFic\AddGadget("id_facture",0,-1,FicForm::#GadgetHide)
    LgnFactureFic\AddGadget("tva",0,-1,FicForm::#GadgetHide)
    LgnFactureFic\AddGadget("pa",0,-1,FicForm::#GadgetHide)
    LgnFactureFic\SetSize(300,0,0,0)
    ; Ajout d'un callback pour mettre à jour la tva et le prix
    LgnFactureFic\AddCallback(@SetTva(),FicForm::#BeforeValide)
  EndProcedure
  Procedure EventSelectFac(id)
    TableLgn\SetFiltersClause(" lgn_facture.id_facture="+Str(id))
    TableLgn\RefreshMe()
    ShowTotal() 
  EndProcedure
  Procedure EditFac()
    Protected Id,IdNumero
    id=TableFac\GetIdSelected()
    If id=-1
      ProcedureReturn 
    EndIf
    FactureFic\Open(DialogWindow(gForm),0,@RefreshFormFac(),FicForm::#ModeEdit,id)
    ; On désactive le champ numero
    IdNumero=FactureFic\GetGadgetId("numero")
    DisableGadget(IdNumero,#True)
  EndProcedure
  Procedure EditLgn()
    Protected Id,IdFac
    id=TableLgn\GetIdSelected()
    IdFac=TableFac\GetIdSelected()
    If id=-1 Or IdFac=-1
      ProcedureReturn 
    EndIf
    LgnFactureFic\SetGadgetValue("id_facture",Str(IdFac))
    LgnFactureFic\Open(DialogWindow(gForm),0,@RefreshFormLgn(),FicForm::#ModeEdit,id)
  EndProcedure
  Procedure DeleteLgn()
    Protected Id,req.s
    id=TableLgn\GetIdSelected()
    If id=-1
      ProcedureReturn 
    EndIf
    If MessageRequester("Suppresiion d'une ligne facture",
       "Etes-vous sure?",
        #PB_MessageRequester_Warning|#PB_MessageRequester_YesNo|#MB_DEFBUTTON2)=#PB_MessageRequester_No
      ProcedureReturn 
    EndIf
    req=" DELETE FROM lgn_facture "+
        " WHERE id="+Str(id)
    DB::Update(req)
    TableFac\RefreshMe()
    
  EndProcedure
  Procedure DeleteFacture()
    Protected Id,req.s
    id=TableFac\GetIdSelected()
    If id=-1
      ProcedureReturn 
    EndIf
    If MessageRequester("Suppresiion d'une facture",
       "Etes-vous sure?",
        #PB_MessageRequester_Warning|#PB_MessageRequester_YesNo|#MB_DEFBUTTON2)=#PB_MessageRequester_No
      ProcedureReturn 
    EndIf
    ; Suppresion des lignes
    req=" DELETE FROM lgn_facture "+
        " WHERE id_facture="+Str(id)
    DB::Update(req)
    ; Suppression de la facture
    req=" DELETE FROM facture "+
        " WHERE id="+Str(id)
    DB::Update(req)
    TableFac\RefreshMe()
  EndProcedure
  ;}-----------------------------------------------------------------------------------------------------------------------------------------------------
  ;======================================================================================================================================================
  ;-* PUBLIC FUNCTIONS
  ; -----------------------------------------------------------------------------------------------------------------------------------------------------
  Procedure Open(motherWindow,TabCli,TabPro)
    Protected xml.s,myXml,IdTableFac,IdTableLgn
    gMotherWindow=motherWindow
    *gTabCli=TabCli
    *gTabPro=TabPro
    MakeFormFic()
    DisableWindow(gMotherWindow,#True)
    xml=MakeXml()
    myXml=CatchXML(#PB_Any, @xml, StringByteLength(xml), 0,#PB_UTF8)
    SetGadgetFont(#PB_Default,FontID(Font))
    If Not myXml Or XMLStatus(myXml) <> #PB_XML_Success
      mError("Open",XMLError(myXml)+" line "+Str(XMLErrorLine(myXml)),#False)
    EndIf
    gForm=CreateDialog(#PB_Any)
    If Not gForm
      mError("Open","Can't create dialog",#False)
    EndIf
    If Not OpenXMLDialog(gForm,myXml,"Facture",0,0,800,600,WindowID(gMotherWindow))
      mError("Open","Can't open dialog",#False)
    EndIf 
    ; Change les polices des titres de table
    SetGadgetFont(DialogGadget(gForm,"Lb_Fac"),FontID(FontH))
    SetGadgetFont(DialogGadget(gForm,"Lb_Lgn"),FontID(FontH))
    ; Création des table
    IdTableFac=DialogGadget(gForm,"canvas_facture")
    IdTableLgn=DialogGadget(gForm,"canvas_Lgn")
    ;--> Table facture
    TableFac=TBL::New(IdTableFac,"facture")
    TableFac\AddColumn("date",0.13)
    TableFac\AddColumn("numero",0.15,TBL::#ShearchOn)
    TableFac\AddColumn("id_client",0.4,TBL::#FiltersOn)
    TableFac\AddColumn("Total",0.1,TBL::#CalculateColumn|TBL::#AlignToRight)
    TableFac\SetCalculateColumnCallBack(@FacTotal())
    TableFac\AddColumn("TVA",0.1,TBL::#CalculateColumn|TBL::#AlignToRight)
    TableFac\SetCalculateColumnCallBack(@FacTVA())
    TableFac\AddColumn("TTC",0.1,TBL::#CalculateColumn|TBL::#AlignToRight)
    TableFac\SetCalculateColumnCallBack(@FacTTC())
    TableFac\SetOrder(" ORDER BY facture.date,client.nom")
    TableFac\SetSelectedCallback(@EventSelectFac())
    
    ;--> Table Lignes de facture
    TableLgn=TBL::New(IdTableLgn,"lgn_facture")
    TableLgn\AddColumn("qte",0.09,TBL::#AlignToRight)
    TableLgn\AddColumn("id_produit",0.5)
    TableLgn\AddColumn("pa",0.1,TBL::#AlignToRight)
    TableLgn\AddColumn("Total",0.1,TBL::#CalculateColumn|TBL::#AlignToRight)
    TableLgn\SetCalculateColumnCallBack(@LgnTotal())
    TableLgn\AddColumn("TVA",0.1,TBL::#CalculateColumn|TBL::#AlignToRight)
    TableLgn\SetCalculateColumnCallBack(@LgnTva())
    TableLgn\AddColumn("TTC",0.1,TBL::#CalculateColumn|TBL::#AlignToRight)
    TableLgn\SetCalculateColumnCallBack(@LgnTTC())
    TableLgn\SetOrder(" ORDER BY produit.nom")
    TableLgn\SetFiltersClause(" lgn_facture.id_facture=-1") ;Pour ne rien afficher
    TableLgn\Draw()
    
    TableFac\Draw()
    ShowTotal() 
    ; Mise en place de la gestion des événement
    BindGadgetEvent(DialogGadget(gForm,"bt_exit"),@Exit())
    BindGadgetEvent(DialogGadget(gForm,"bt_addFac"),@NewFac())
    BindGadgetEvent(DialogGadget(gForm,"bt_addLgn"),@NewLgn())
    BindGadgetEvent(DialogGadget(gForm,"bt_editFac"),@EditFac())
    BindGadgetEvent(DialogGadget(gForm,"bt_editLgn"),@EditLgn())
    BindGadgetEvent(DialogGadget(gForm,"bt_deleteLgn"),@DeleteLgn())
    BindGadgetEvent(DialogGadget(gForm,"bt_deleteFac"),@DeleteFacture())
    BindEvent(#PB_Event_CloseWindow,@Exit(),DialogWindow(gForm))
  EndProcedure
  ;}-----------------------------------------------------------------------------------------------------------------------------------------------------
EndModule
; IDE Options = PureBasic 5.60 (Windows - x64)
; CursorPosition = 392
; FirstLine = 171
; Folding = AhBAA-
; EnableXP