﻿IncludePath "..\RAD"
XIncludeFile "DB.pbi"
XIncludeFile "RAD.pbi"
XIncludeFile "FicForm.pbi"
XIncludeFile "TabForm.pbi"
Enumeration 
  #M_Pays
  #M_Localite
  #M_Client
  #M_Facture
  #M_Categorie
  #M_SousCategorie
  #M_Produit
  #M_Tva
  #M_Exit
EndEnumeration

Global gForm,gMenu

Global.RAD::_FicForm paysFic,localiteFic,categorieFic,SousCategorieFic,TvaFic,ClientFic,ProduitFic
Global.RAD::_TabForm paysTab,localiteTab,categorieTab,SousCategorieTab,TvaTab,ClientTab,ProduitTab

;-* Pays
paysFic=FicForm::New("pays","Nouveau pays","Edition d'un pays")
paysFic\SetSize(300,0,0,0)
paysFic\AddGadget("nom")

paysTab=TabForm::New("pays","Liste des pays",800,600,paysFic)
paysTab\AddColumn("nom",1,TabForm::#ShearchOn)
paysTab\SetOrder("pays.nom")
;}
;-* Localités
localiteFic=FicForm::New("localite","Nouvelle localité","Edition d'une localité")
localiteFic\SetSize(300,0,0,0)
localiteFic\AddGadget("id_pays",0,paysTab)
localiteFic\AddGadget("nom")
localiteFic\AddGadget("code")

localiteTab=TabForm::New("localite","Liste des localité",800,600,localiteFic)
localiteTab\AddColumn("id_pays",0.4,TabForm::#FiltersOn)
localiteTab\AddColumn("nom",0.4,TabForm::#ShearchOn)
localiteTab\AddColumn("code",0.2)
localiteTab\SetOrder("pays.nom,localite.nom")
;}
;-* Categorie
categorieFic=FicForm::New("categorie","Nouvelle catégorie","Edition d'une catégorie")
categorieFic\SetSize(300,0,0,0)
categorieFic\AddGadget("nom")

categorieTab=TabForm::New("categorie","Liste des catégories",800,600,categorieFic)
categorieTab\AddColumn("nom",1,TabForm::#ShearchOn)
categorieTab\SetOrder("categorie.nom")
;}
;-* Sous-categorie
SousCategorieFic=FicForm::New("sous_categorie","Nouvelle sous-catégorie","Edition d'une sous-catégorie")
SousCategorieFic\SetSize(300,0,0,0)
SousCategorieFic\AddGadget("id_categorie",0,categorieTab)
SousCategorieFic\AddGadget("nom")

SousCategorieTab=TabForm::New("sous_categorie","Liste des sous-catégories",800,600,SousCategorieFic)
SousCategorieTab\AddColumn("id_categorie",0.5,TabForm::#FiltersOn)
SousCategorieTab\AddColumn("nom",0.5,TabForm::#ShearchOn)
SousCategorieTab\SetOrder("categorie.nom,sous_categorie.nom")
;}
;-* Tva
TvaFic=FicForm::New("tva","Nouveau taux de TVA","Edition dun taux de TVA")
TvaFic\SetSize(200,0,0,0)
TvaFic\AddGadget("taux")

TvaTab=TabForm::New("tva","Liste des sous-catégories",300,600,TvaFic)
TvaTab\AddColumn("taux",1)
TvaTab\SetOrder("tva.taux")
;}
;-* Client
ClientFic=FicForm::New("client","Nouveau client","Edition d'un client",2)
ClientFic\SetSize(400,0,0,0)
ClientFic\AddGadget("nom",2)
ClientFic\AddGadget("adresse",2)
ClientFic\AddGadget("id_localite",2,localiteTab)
ClientFic\AddGadget("telephone")
ClientFic\AddGadget("gsm")
ClientFic\AddGadget("email",2)
ClientFic\AddGadget("remarque",2)

ClientTab=TabForm::New("client","Liste des clients",800,600,ClientFic)
ClientTab\AddColumn("id_localite",0.3,TabForm::#FiltersOn)
ClientTab\AddColumn("nom",0.7,TabForm::#ShearchOn)
ClientTab\SetOrder("localite.nom,client.nom")
;}
;-* Produits
ProduitFic=FicForm::New("produit","Nouveau produit","Edition d'un produit",2)
ProduitFic\SetSize(400,0,0,0)

ProduitFic\AddGadget("id_categorie",0,SousCategorieTab)
ProduitFic\AddGadget("id_tva",0,TvaTab)
ProduitFic\AddGadget("nom",2)
ProduitFic\AddGadget("pa")
ProduitFic\AddGadget("pv")

ProduitTab=TabForm::New("produit","Liste des produits",800,600,ProduitFic)
ProduitTab\AddColumn("id_categorie",0.3,TabForm::#FiltersOn)
ProduitTab\AddColumn("nom",0.5,TabForm::#ShearchOn)
ProduitTab\AddColumn("pv",0.2,TabForm::#AlignToRight)
ProduitTab\SetOrder("sous_categorie.nom,produit.nom")
;}
Procedure Exit()
  CloseWindow(gForm)
  End
EndProcedure
Procedure MakeDb()
  If Not DB::Init("DATA","Facture.sqlite","","")
    End
  EndIf
  ;-* Table pays
  DB::AddTable("pays","id") 
  DB::AddColumn("nom","Pays",DB::#Type_Text,DB::#Not_Null|DB::#Unique)
  ;}
  ;-* Table localité
  DB::AddTable("localite","id")
  DB::AddColumn("nom","Localité",DB::#Type_Text,DB::#Not_Null)
  DB::AddColumn("code","Code postal",DB::#Type_Text,DB::#Not_Null)
  DB::AddColumn("id_pays","Pays",DB::#Type_Link,DB::#Not_Null,"pays","id","nom") 
  DB::AddCompositeKey("nom"+Chr(10)+"id_pays"+Chr(10)+"code")
  ;}
  ;-* Table client
  DB::AddTable("client","id")
  DB::AddColumn("nom","Nom",DB::#Type_Text,DB::#Not_Null)
  DB::AddColumn("adresse","Adresse",DB::#Type_Text,DB::#Not_Null)
  DB::AddColumn("telephone","Téléphone",DB::#Type_Phone)
  DB::AddColumn("gsm","GSM",DB::#Type_Phone)
  DB::AddColumn("email","Email",DB::#Type_Email)
  DB::AddColumn("remarque","Remarque",DB::#Type_Note)
  DB::AddColumn("id_localite","Localité",DB::#Type_Link,DB::#Not_Null,"localite","id","nom")
  DB::AddCompositeKey("nom"+Chr(10)+"id_localite"+Chr(10)+"adresse")
  ;}
  ;-* Table Categorie
  DB::AddTable("categorie","id")
  DB::AddColumn("nom","Catégorie",DB::#Type_Text,DB::#Not_Null|DB::#Unique)
  ;}
  ;-* Table sous-Categorie
  DB::AddTable("sous_categorie","id")
  DB::AddColumn("nom","Sous-Catégorie",DB::#Type_Text,DB::#Not_Null|DB::#Unique)
  DB::AddColumn("id_categorie","Catégorie",DB::#Type_Link,DB::#Not_Null,"categorie","id","nom")
  ;}
  ;-* Table tva
  DB::AddTable("tva","id")
  DB::AddColumn("taux","Taux",DB::#Type_Percentage,DB::#Not_Null|DB::#Unique)
  ;}
  ;-* Table produit
  DB::AddTable("produit","id")
  DB::AddColumn("nom","Nom",DB::#Type_Text,DB::#Not_Null)
  DB::AddColumn("pa","Prix d'achat",DB::#Type_Euro,DB::#Not_Null)
  DB::AddColumn("pv","Prix de vente",DB::#Type_Euro,DB::#Not_Null)
  DB::AddColumn("id_categorie","Catégorie",DB::#Type_Link,DB::#Not_Null,"sous_categorie","id","nom")
  DB::AddColumn("id_tva","Taux de Tva",DB::#Type_Link,DB::#Not_Null,"tva","id","taux")
  ;}
  ;-* Table facture
  DB::AddTable("facture","id")
  DB::AddColumn("numero","Numéro",DB::#Type_Text,DB::#Not_Null|DB::#Unique)
  DB::AddColumn("date","Date",DB::#Type_Date,DB::#Not_Null)
  DB::AddColumn("id_client","Client",DB::#Type_Link,DB::#Not_Null,"client","id","nom")
  ;}
  ;-* Table lgn facture
  DB::AddTable("lgn_facture","id")
  DB::AddColumn("qte","Quantité",DB::#Type_Integer,DB::#Not_Null)
  DB::AddColumn("pa","Prix d'achat",DB::#Type_Euro,DB::#Not_Null)
  DB::AddColumn("tva","Taux de TVA",DB::#Type_Percentage,DB::#Not_Null)
  DB::AddColumn("id_produit","Produit",DB::#Type_Link,DB::#Not_Null,"produit","id","nom")
  DB::AddColumn("id_facture","Facture",DB::#Type_Link,DB::#Not_Null,"facture","id","id")
  ;}
  DB::Build()
EndProcedure
Procedure MakeMenu()
  gMenu=CreateMenu(#PB_Any,WindowID(gForm))
  MenuTitle("Fichier")
  MenuItem(#M_Pays,"Pays")
  MenuItem(#M_Localite,"Localités")
  MenuItem(#M_Client,"Client")
  MenuItem(#M_Categorie,"Catégorie")
  MenuItem(#M_SousCategorie,"Sous-catégorie")
  MenuItem(#M_Tva,"Taux de tva")
  MenuItem(#M_Produit,"Produits")
  MenuBar()
  MenuItem(#M_Exit,"Quitter")
EndProcedure
Procedure myEventMenu()
  Select EventMenu()
    Case  #M_Pays
      paysTab\Open(gForm)
    Case #M_Localite
      LocaliteTab\Open(gForm)
    Case #M_Categorie  
      categorieTab\Open(gForm)
    Case #M_SousCategorie
      SousCategorieTab\Open(gForm)
    Case #M_Tva
      TvaTab\Open(gForm)
    Case #M_Client
      ClientTab\Open(gForm)
    Case #M_Produit
      ProduitTab\Open(gForm)
    Case #M_Exit
      Exit()
  EndSelect
EndProcedure
Procedure Open()
  Protected flag.l=#PB_Window_SystemMenu|#PB_Window_MaximizeGadget|#PB_Window_MinimizeGadget|#PB_Window_SizeGadget|#PB_Window_ScreenCentered
  gForm=OpenWindow(#PB_Any,0,0,800,600,"Logiciel de facturation",flag)
  MakeMenu()
  BindEvent(#PB_Event_CloseWindow,@Exit(),gForm)
  BindEvent(#PB_Event_Menu,@myEventMenu(),gForm)
EndProcedure
MakeDb()
Open()
Repeat
  WaitWindowEvent()
ForEver 
; IDE Options = PureBasic 5.60 (Windows - x64)
; CursorPosition = 200
; FirstLine = 120
; Folding = -b--
; Markers = 94,149
; EnableXP