﻿; *******************************************************************************************************************************************************
; AUTHOR        : MicrodevWeb
; PROJECT NAME  : RAD
; CLASS NAME    : RAD
; VERSION       : 1
; REQUIERED     : PB 5.60
; *******************************************************************************************************************************************************
DeclareModule RAD
  ;======================================================================================================================================================
  ;-* PUBLIC CONSTANTE
  ; -----------------------------------------------------------------------------------------------------------------------------------------------------
  EnumerationBinary 
    #SelectMode
  EndEnumeration
  EnumerationBinary 
    #ModeEdit
  EndEnumeration
  EnumerationBinary 
    #ShearchOn
    #FiltersOn
    #AlignToRight
    #AlignToCenter
    #CalculateColumn
  EndEnumeration  
  EnumerationBinary 
    #GadgetHide
  EndEnumeration
  
  ;}-----------------------------------------------------------------------------------------------------------------------------------------------------
  ;======================================================================================================================================================
  ;-* PUBLIC INTERFACE
  ; -----------------------------------------------------------------------------------------------------------------------------------------------------
  Interface _TabForm
    Open(MotherWindow=-1,Flag.l=0,*Callback=0)
    AddColumn(ColumnName.s,Width.f,flag.l=0)
    SetOrder(OrderClause.s)
  EndInterface
  Interface _FicForm
    Open(MotherWindow=-1,*From=0,*Callback=0,flag.l=0,CurrentRecord=0)
    AddGadget(Name.s,MergedColumn=0,TabForm=-1,Flag.l=0)
    SetSize(minWidth,minHeight,maxWidth,maxHeight)
    GetGadgetId(GadgetName.s)
    SetGadgetValue(GadgetName.s,Value.s)
    AddLinkedData(columnId.s,columnLinked.s,TableLinked.s,StrangerColumn.s)
    Free()
    AddCallback(*CallBack,flag.l)
  EndInterface
  ;}-----------------------------------------------------------------------------------------------------------------------------------------------------
  ;======================================================================================================================================================
  ;-* PUBLIC PROTOTYPES
  ; -----------------------------------------------------------------------------------------------------------------------------------------------------
  Declare MaskingString(Gadget,mask,NbDecimal=0,Ext$="")
  ;}-----------------------------------------------------------------------------------------------------------------------------------------------------
EndDeclareModule
Module RAD
  EnableExplicit
  UseSQLiteDatabase()
  ;======================================================================================================================================================
  ;-* PRIVATE CONSTANTE
  ; -----------------------------------------------------------------------------------------------------------------------------------------------------
  ;}-----------------------------------------------------------------------------------------------------------------------------------------------------
  ;======================================================================================================================================================
  ;-* PRIVATE STRUCTURES
  ; -----------------------------------------------------------------------------------------------------------------------------------------------------
  ;}-----------------------------------------------------------------------------------------------------------------------------------------------------
  ;======================================================================================================================================================
  ;-* PRIVATE VARIABLES
  ; -----------------------------------------------------------------------------------------------------------------------------------------------------
  ;}-----------------------------------------------------------------------------------------------------------------------------------------------------
  ;======================================================================================================================================================
  ;-* PRIVATE PROTOTYPES
  ; -----------------------------------------------------------------------------------------------------------------------------------------------------
  ;}-----------------------------------------------------------------------------------------------------------------------------------------------------
  ;======================================================================================================================================================
  ;-* PRIVATE FUNCTIONS
  ; -----------------------------------------------------------------------------------------------------------------------------------------------------
  ;}-----------------------------------------------------------------------------------------------------------------------------------------------------
  ;======================================================================================================================================================
  ;-* PUBLIC FUNCTIONS
  ; -----------------------------------------------------------------------------------------------------------------------------------------------------
  Procedure MaskingString(Gadget,mask,NbDecimal=0,Ext$="")
    Protected txt$,PosStart.i,PosEnd.i,N,Car$
    Protected number$="0123456789"
    Protected phone$="0123456789-/\:. "
    Protected FileCar.s="ABCDEFGHIJKLMNOPQRSTVWXYZabcdefghijklmnopqrstvwxyz_"
    Protected Dec=-1
    If EventType()=#PB_EventType_Change
      SendMessage_(GadgetID(Gadget),#EM_GETSEL,@PosStart,@PosEnd)
      Select mask
        Case 1 ;Première lettre en majuscule
          txt$=UCase(Left(GetGadgetText(Gadget),1))+Right(GetGadgetText(Gadget),Len(GetGadgetText(Gadget))-1)
        Case 2 ;Tout en majuscule
          txt$=UCase(GetGadgetText(Gadget))
        Case 3 ;Tout en miniscule
          txt$=LCase(GetGadgetText(Gadget))
        Case 4 ;Numérique
          For N=1 To Len(GetGadgetText(Gadget))
            Car$=Mid(GetGadgetText(Gadget),N,1)
            If N=1 And Car$="-"
              txt$+Car$
            Else
              If FindString(number$,Car$)<>0
                If Dec=-1
                  txt$+Car$
                Else
                  If Dec<NbDecimal
                    txt$+Car$
                    Dec+1
                  EndIf
                EndIf
                
              EndIf
              If NbDecimal>0
                If Car$="." And Dec=-1
                  txt$+"."
                  Dec=0
                EndIf
              EndIf
            EndIf
          Next
        Case 5 ;Phone
          For N=1 To Len(GetGadgetText(Gadget))
            Car$=Mid(GetGadgetText(Gadget),N,1)
            If FindString(phone$,Car$)<>0
              txt$+Car$
            EndIf
          Next
        Case 6 ; FileNamùe
          For N=1 To Len(GetGadgetText(Gadget))
            Car$=Mid(GetGadgetText(Gadget),N,1)
            If FindString(FileCar,Car$)<>0
              txt$+Car$
            EndIf
          Next
      EndSelect
      If Ext$<>""
        txt$+Ext$
      EndIf
      SetGadgetText(Gadget,txt$)
      SendMessage_(GadgetID(Gadget),#EM_SETSEL,PosStart,PosEnd)
    EndIf
  EndProcedure
  ;}-----------------------------------------------------------------------------------------------------------------------------------------------------
EndModule
; IDE Options = PureBasic 5.60 (Windows - x64)
; CursorPosition = 45
; FirstLine = 23
; Folding = ---
; EnableXP